package CalculusAndVectors;

import java.lang.Math;

/**
 Auxiliary (vectore) procedures for multivariable calculations.
 Just a mess of different things ...
*/
public class Vec {

   static final double PI             = Math.PI;
   public static final double DPI     = 2.*Math.PI;
   public static final double PI2     = Math.PI/2.;
   public static final double PI4     = Math.PI/4.;
   public static final double RAD2DEG = 180./Math.PI;
   public static final double LG10    = Math.log(10.);

   //Deviation of diagonal members:
   public static double a11,a22,a33;
   public static double a21,a31,a32;

   
   /** Reduces psy to interval [-PI,PI). 
       Cycle limit = 100 to prevent infinite loop
       possibly due computer inaccuracy.
       .do1 Method does not indicate failure.
            Make sure that callers handle this failure.
   */
   public static double fixAzi( double psy ) {
       for(int i=0; i<100; i++) {
          if( psy >= PI ) {
              psy -= DPI;
          } else {
            if( psy < -PI ) { 
                psy += DPI;
            }else{
                return psy; //Success.
            }
          }
       }
       return psy;  //No success. 
                    //Unlikely but perhaps due 
                    //computer arithmetic inaccuracy.
  }


  //Calculate mean quadratice deviation of u*u~ from
  //diagonal matrix:
  public static double UBasisDeviation( UBasis u ) {
         
         double d=0;

         //Localize references:
         double v11 = u.e[0].x;
         double v21 = u.e[0].y;
         double v31 = u.e[0].z;

         double v12 = u.e[1].x;
         double v22 = u.e[1].y;
         double v32 = u.e[1].z;

         double v13 = u.e[2].x;
         double v23 = u.e[2].y;
         double v33 = u.e[2].z;

         //Deviation of diagonal members:
         a11 = v11*v11 + v21*v21 + v31*v31 - 1.;
         a22 = v12*v12 + v22*v22 + v32*v32 - 1.;
         a33 = v13*v13 + v23*v23 + v33*v33 - 1.;
         
         d += a11*a11 + a22*a22 + a33*a33;

         a21 = v12*v11 + v22*v21 + v32*v31;
         a31 = v13*v11 + v23*v21 + v33*v31;
         a32 = v13*v12 + v23*v22 + v33*v32;

         d += 2.*(a21*a21 + a31*a31 + a32*a32);

         return d/9.;

  }



  //Radian to Degrees with two digits after period:
  //Usage: + rad2Degr2(dd) + "^ ");
  public static double rad2Degr( double d) {
         int i = (int)(100.*RAD2DEG*d);
         return ((double)i)/100.;
  }

}
 
           
       